<template>
  <div data-view="users">
    <Can
      I="store"
      a="user"
    >
      <AddNewUserDialog
        :is-on="isNewUserModalOn"
        :is-loading="isAddingUser"
        :on-cancel="toggleNewUserModal"
        :on-confirm="createUser"
      />
    </Can>

    <Can
      I="update"
      a="user"
    >
      <EditUserDialog
        :user="selectedUser"
        :is-on="isEditUserModalOn"
        :is-loading="isEditingUser"
        :on-cancel="toggleEditUserModal"
        :on-confirm="$ability.can('update', 'user') ? updateUser : undefined"
      />
    </Can>

    <layout-logged-frame :has-aside="hasFilters">
      <template slot="aside">
        <UserFilters
          @filter="onFilter"
          @clearFilters="onClearFilters"
        />
      </template>
      <template slot="content">
        <base-table
          v-if="pendingUsers.length > 0"
          :columns="pendingColumns"
          :items="pendingUsers"
          :title="`${pendingPagination.totalItems || 0} users`"
          :pages="totalPendingPages"
          :pagination="pendingPagination"
          :is-loading="isPendingLoading"
          :on-select-item="selectUser"
          :on-update-pagination="onUpdatePendingPagination"
          :on-change-page="onChangePendingPage"
        >
          <template slot="title">
            <h1>{{ 'Pending review' }}</h1>
            <span class="heading-separator">
              {{ ' / ' }}
            </span>
            <h2>{{ `${totalPendingCount} user${totalPendingCount > 1 ? 's' : ''}` }}</h2>
          </template>
        </base-table>

        <base-table
          :columns="columns"
          :items="users"
          :pages="totalPages"
          :pagination="pagination"
          :is-loading="isLoading"
          :has-custom-items-template="true"
          :on-select-item="selectUser"
          :on-update-pagination="onUpdatePagination"
          :on-change-page="onChangePage"
        >
          <template slot="title">
            <h1>{{ 'All' }}</h1>
            <span class="heading-separator">
              {{ ' / ' }}
            </span>
            <h2>{{ `${totalCount} user${totalCount > 1 ? 's' : ''}` }}</h2>
          </template>

          <template
            slot="item-cell"
            slot-scope="scope"
          >
            <div v-if="scope.cell.column.value === 'status.name'">
              <UserStatus :user="scope.cell.item" />
            </div>
            <div v-else>
              {{ displayColumnValue(scope.cell.item, scope.cell.column.value) }}
            </div>
          </template>

          <template slot="actions">
            <Can
              I="store"
              a="user"
            >
              <v-btn
                class="trigger add-new-item"
                color="secondary"
                @click="toggleNewUserModal"
              >
                <v-icon>
                  person_add
                </v-icon>
                {{ 'Add new user' }}
              </v-btn>
            </Can>
          </template>
        </base-table>
      </template>
    </layout-logged-frame>
  </div>
</template>

<script>
  import UserFilters from '../../components/forms/filters/User';
  import AddNewUserDialog from '../../components/dialogs/user/AddNew';
  import EditUserDialog from '../../components/dialogs/user/Edit';
  import UserStatus from '../../components/panels/users/Status';
  import { isStr, isNum, isObj, extractNestedProp } from '../../utils';
  import columns from '../../config/users/columns';

  // TODO: Translate component

  const pendingColumns = _.cloneDeep(columns);

  export default {
    components: {
      UserFilters,
      AddNewUserDialog,
      EditUserDialog,
      UserStatus
    },
    data() {
      return {
        columns,
        pendingColumns,
        pagination: {
          descending: true,
          page: 1,
          rowsPerPage: 15,
          sortBy: 'created_at',
          totalItems: 0,
          search: ''
        },
        pendingPagination: {
          descending: false,
          page: 1,
          rowsPerPage: 15,
          sortBy: 'created_at',
          totalItems: 0,
          search: ''
        },
        selectedUser: {},
        totalPages: 0,
        totalPendingPages: 0,
        query: {},
        pendingQuery: {},
        isNewUserModalOn: false,
        isEditUserModalOn: false,
        isLoading: false,
        isPendingLoading: false,
        isAddingUser: false,
        isEditingUser: false
      };
    },
    computed: {
      users() {
        return this.$store.getters['users/items'];
      },
      pendingUsers() {
        return this.$store.getters['users/pendingItems'];
      },
      selectedCountry() {
        return this.$store.getters['config/country'];
      },
      totalCount() {
        return this.pagination.totalItems || 0;
      },
      totalPendingCount() {
        return this.pendingPagination.totalItems || 0;
      },
      hasFilters() {
        return this.$ability.can('see-user-status', 'filter')
          || this.$ability.can('see-user-role', 'filter')
          || this.$ability.can('see-user-search', 'filter')
          || this.$ability.can('see-user-business', 'filter');
      }
    },
    created() {
      const { query, pendingQuery, pagination } = this;
      const { sortBy } = pagination;

      this.getUsers({
        ...query,
        sort: sortBy
      });
      this.getPendingUsers({
        ...pendingQuery,
        sort: sortBy
      });
      this.getAssignmentTypes();
    },
    methods: {
      getUsers({ page = 1, order = 'asc', sort = '', search = '', role = '', businessId = -1 } = {}) {
        const query = {
          page,
          order,
          sort,
          search,
          role,
          businessId
        };

        this.isLoading = true;
        this.pagination.descending = order === 'desc';

        if (sort !== '') {
          this.pagination.sortBy = sort;
        }

        return this.$store.dispatch('users/getItems', query)
          .then((res) => {
            const { itemsMeta } = this.$store.getters['users/itemsData'];
            const { total, current_page, last_page } = itemsMeta;

            this.pagination.page = current_page;
            this.pagination.totalItems = total;
            this.totalPages = last_page;
            this.isLoading = false;

            return res;
          })
          .catch((err) => {
            this.isLoading = false;
            return err;
          });
      },
      getPendingUsers({ page = 1, order = 'asc', sort = '', search = '', role = '', businessId = -1 } = {}) {
        const query = {
          page,
          order,
          sort,
          search,
          role,
          businessId
        };

        this.isPendingLoading = true;
        this.pendingPagination.descending = order === 'desc';

        if (sort !== '') {
          this.pendingPagination.sortBy = sort;
        }

        return this.$store.dispatch('users/getPendingItems', query)
          .then((res) => {
            const { meta } = this.$store.getters['users/pendingItemsData'];
            const { total, current_page, last_page } = meta;

            this.pendingPagination.page = current_page;
            this.pendingPagination.totalItems = total;
            this.totalPendingPages = last_page;
            this.isPendingLoading = false;

            return res;
          })
          .catch((err) => {
            this.isPendingLoading = false;
            return err;
          });
      },
      createUser(user) {
        this.isAddingUser = true;

        return this.$store.dispatch('users/create', user)
          .then(() => {
            const { sortBy } = this.pagination;
            const nextQuery = {
              ...this.query,
              sort: sortBy
            };

            this.isAddingUser = false;
            this.isNewUserModalOn = false;

            return this.getUsers(nextQuery);
          })
          .catch((err) => {
            this.isAddingUser = false;
            return err;
          });
      },
      updateUser(user) {
        const nextUser = {
          ...user,
          id: this.selectedUser.id
        };

        this.isEditingUser = true;

        return this.$store.dispatch('users/update', nextUser)
          .then(() => {
            const { sortBy } = this.pagination;
            const nextQuery = {
              ...this.query,
              sort: sortBy
            };

            this.isEditingUser = false;
            this.isEditUserModalOn = false;

            const activeUser = this.$store.getters['users/activeItem'];

            const hasUpdatedStatus = isObj(this.selectedUser.status)
              && this.selectedUser.status.id !== activeUser.status.id;

            if (hasUpdatedStatus) {
              this.selectedUser = {
                ...this.selectedUser,
                status: activeUser.status
              };
            }

            this.getUsers(nextQuery);
            return this.getPendingUsers({ sort: sortBy });
          })
          .catch((err) => {
            this.isEditingUser = false;
            return err;
          });
      },
      selectUser(user) {
        this.selectedUser = user;
        this.isEditUserModalOn = true;

        return this.$store.dispatch('users/setActiveItem', user);
      },
      onUpdatePagination({ page, descending, sortBy }) {
        const { query, pagination } = this;
        const nextQuery = {
          ...query,
          page,
          order: descending ? 'desc' : 'asc',
          sort: isStr(sortBy) ? sortBy : pagination.sortBy
        };

        this.query = nextQuery;

        this.getUsers(nextQuery);
      },
      onUpdatePendingPagination({ page, descending, sortBy }) {
        const { pendingQuery, pendingPagination } = this;
        const nextQuery = {
          ...pendingQuery,
          page,
          order: descending ? 'desc' : 'asc',
          sort: isStr(sortBy) ? sortBy : pendingPagination.sortBy
        };

        this.pendingQuery = nextQuery;

        this.getPendingUsers(nextQuery);
      },
      onChangePage(page) {
        const { query, pagination } = this;
        const { descending, sortBy } = pagination;
        const nextQuery = {
          ...query,
          page,
          order: descending ? 'desc' : 'asc',
          sort: sortBy
        };

        this.query = nextQuery;

        this.getUsers(nextQuery);
      },
      onChangePendingPage(page) {
        const { pendingQuery, pendingPagination } = this;
        const { descending, sortBy } = pendingPagination;
        const nextQuery = {
          ...pendingQuery,
          page,
          order: descending ? 'desc' : 'asc',
          sort: sortBy
        };

        this.pendingQuery = nextQuery;

        this.getPendingUsers(nextQuery);
      },
      onFilter(filters) {
        this.query = {
          ...this.query,
          ...this.getSearchQuery(filters)
        };

        this.pendingQuery = {
          ...this.pendingQuery,
          ...this.getSearchQuery(filters)
        };

        this.getUsers(this.query);
        this.getPendingUsers(this.pendingQuery);
      },
      onClearFilters() {
        const { sortBy } = this.pagination;
        const nextQuery = { sort: sortBy };
        this.query = nextQuery;
        this.pendingQuery = nextQuery;

        this.getUsers(this.query);
        this.getPendingUsers(this.pendingQuery);
      },
      getSearchQuery({ search, business, role, status }) {
        const query = {};

        if (search !== '') {
          query.search = search;
        }

        if (isNum(business)) {
          query.businessId = business;
        }

        if (isStr(role)) {
          query.role = role;
        }

        if (isNum(status)) {
          query.status = status;
        }

        return query;
      },
      getAssignmentTypes() {
        return this.$store.dispatch('users/getAssignmentTypes');
      },
      toggleNewUserModal() {
        this.isNewUserModalOn = !this.isNewUserModalOn;
      },
      toggleEditUserModal() {
        this.isEditUserModalOn = !this.isEditUserModalOn;

        if (!this.isEditUserModalOn) {
          this.getUsers(this.query);
          this.getPendingUsers(this.pendingQuery);
        }
      },
      displayColumnValue(item, columnValue) {
        return extractNestedProp(item, columnValue);
      }
    },
    metaInfo() {
      return {
        title: 'Users'
      };
    }
  };
</script>

<style lang="stylus">
  .v-datatable {
    min-width: $min-table-width;
  }
</style>
